program Project2;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils,
  System.StrUtils,
  System.Classes,
  FMX.Forms,
  FMX.Dialogs,
  IdWebDAV,
  IdURI;

type
  TGetThread = class(TThread)
  private
    FURL, FFileName: String;
    FRunning: Boolean;
    FReply: String;
    FResult: Boolean;
    procedure DoAfterSync;
  protected
    sErrMsg: string;
    procedure Execute ; override;
  public
    constructor Create(URL, FileName: String);
    property Running: Boolean read FRunning;
    function GetReply(var Reply: String): Boolean;
  end;

  TThreadMain = class(TThread)
  private
    procedure Execute; override;
  end;

function DAVGetFile(Source: String; Target: String): String;
var
  URL: String;
  IdWebDAV: TIdWebDAV;
  Stream: TFileStream;
begin
  Result := '';
  try
    IdWebDAV := TIdWebDAV.Create(nil);
    IdWebDAV.Request.BasicAuthentication := True;
    IdWebDAV.Request.Username := 'User';
    IdWebDAV.Request.Password := 'Password';
    IdWebDAV.ReadTimeout := 10000;
    IdWebDAV.Request.CacheControl := 'no-cache';
    URL := TIdUri.URLEncode(Source);
    try
      Stream := TFileStream.Create(Target, fmCreate or fmOpenWrite);
      IdWebDAV.Get(URL, Stream);
      FreeAndNil(Stream);
    except
      on e:exception do
      // ShowMessage (e.message);
        Result := e.message;
    end;
  finally
    FreeAndNil(IdWebDAV);
  end;
end;

constructor TGetThread.Create(URL, FileName: String);
begin
  inherited Create(True);
  FURL := URL;
  FFileName := FileName;
  FRunning := True;
  FReply := '';
  Resume;
end;

procedure TGetThread.Execute;
var
  Text: string;
begin
  FRunning := true;
  sErrMsg := DAVGetFile(FURL, FFileName);
  FResult := sErrMsg = '';
  FReply := ifThen(sErrMsg <> '', sErrMsg, '');
//  Synchronize(DoAfterSync);
  FRunning := False;
end;

function TGetThread.GetReply(var Reply: String): Boolean;
begin
  Reply := FReply;
  Result := FResult;
end;

procedure TGetThread.DoAfterSync;
begin
  FRunning := False;
end;

procedure TThreadMain.Execute;
var
  GetThread: TGetThread;
begin
  GetThread := TGetThread.Create('http://10.1.1.1:8080/ABC.zip', 'C:\Temp\ABC.zip');
  while GetThread.Running do Application.ProcessMessages;
  ShowMessage('Completed');
end;

var
  GetThread: TGetThread;
  ThreadMain: TThreadMain;
  Key: Char;
begin
  try
    ThreadMain := TThreadMain.Create(false);
    { TODO -oUser -cConsole Main : Insert code here }
    while True do begin
       Read(Key);
    end;
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
